use dashmap::DashMap;


thread_local! {
  static CTRMAP: DashMap<&'static str, usize> = DashMap::new();
}

const EXISTENTIALS: [&'static str; 24] = [
  "α", "β", "γ", "δ", "ε", "ζ", "η", "θ", "ι", "κ", "λ", "μ", "ν", "ξ", "ο",
  "π", "ρ", "σ", "τ", "υ", "φ", "χ", "ψ", "ω",
];

const TYPEVARS: [&'static str; 26] = [
  "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O",
  "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z",
];

pub fn gensym_existential() -> String {
  let result = idx("existential");
  format!("{}\u{0302}", EXISTENTIALS[result])
}

pub fn gensym_type() -> String {
  let result = idx("existential");
  format!("{}\u{0302}", TYPEVARS[result])
}

fn idx(ty: &'static str) -> usize {
  CTRMAP.with(|ctrmap| {
    let mut g = ctrmap.entry(ty).or_insert(0);
    let ctr = *g;
    *g += 1;
    ctr
  })
}
